#include <iostream>
#include <string>

#include "rateconn.H"


using namespace std;

RateconnCheck rateconnCheck;


extern "C" void rateconnInitWrapper() throw () {
    rateconnCheck = RateconnCheck();
}

extern "C" int rateconnCheckWrapper(const char* input) throw () {
    return rateconnCheck.check(string(input));
}



/**
- a certain number of hashes, sitting on a kind of a chain
- periodically the chain is moved a step forward, the last hash while be dropped
  off from the end of the chain and wiped out, a new one is create and put at the
  first position of the chain
- new entries a put into the first one
- all hashes are considered when calculating the number of events in a timespan
- 



*/

RateconnCheck::RateconnCheck() {
    moveChain();
}

void RateconnCheck::moveChain() {
    if (m_countersDeque.size() > numOfBuckets)
        m_countersDeque.pop_back();
    counterMap_t tmpMap = counterMap_t();
    m_countersDeque.push_front(tmpMap);
}

void RateconnCheck::printAll() {
    for (countersDeque_t::const_iterator i = m_countersDeque.begin(); i != m_countersDeque.end(); ++i) {
        for (counterMap_t::const_iterator j = i->begin(); j != i->end(); ++j) {
            cout << "key: " << j->first << ", value: " << j->second << endl;
        }
    }
}


int RateconnCheck::check(const string& input) {
    counterMap_t& cm = m_countersDeque.front();
    if (cm.find(input) == 0)
        cm[input] = 0;
    cm[input]++;
    
    printAll();
    
    return 0;
}


